#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <gsl/gsl_vector.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_multifit_nlin.h>




#define Row_max	10000
#define Col_max	20
#define Param_max 50



typedef struct 
{
	double Data_array[Row_max][2];
	double Result_array[Row_max][3];
	double Limit_array[Param_max];
	double Parameter_array[Param_max][2];
	int Row_no,Parameter_no,Col_no,Iterations;
	double Chi_square;

}Data_struct;


#include "LVM_algorithm_modified.c"

int LVM_algorithm(Data_struct *Data_structure_ptr);

int main (void)
{
	int i,j,k;

	FILE *infile, *outfile;
	char line[300],*args, args_1[200];

	Data_struct Data_structure,*Data_structure_ptr;
	Data_structure_ptr = &Data_structure;


	infile = fopen("Data","r");
	fgets(line,sizeof(line),infile);
	i=0;
	while(!feof(infile))
	{
		fgets(line,sizeof(line),infile);
		i++;
	}
	fclose(infile);
	

	Data_structure.Row_no = i;

	infile = fopen("Data","r");
	fgets(line,sizeof(line),infile);
	i=0;
	while(!feof(infile))
	{	j=0;
		args=strtok(line," \t");
		while(args !=NULL)
		{
			strcpy(args_1,args);
			for(k=0;k<strlen(args_1);k++)
			{if(args_1[k] == '\n'){args_1[k] = '\0';} }
			if(j==0){Data_structure.Data_array[i][0]=atof(args_1);}
			if(j==1){Data_structure.Data_array[i][1]=atof(args_1);}
			j++;
			args=strtok(NULL," \t");

		}


		fgets(line,sizeof(line),infile);
		i++;
	}


	// Test printing
	for (i = 0; i < Data_structure.Row_no; i++)
	{
		printf ("data: %u\t%lf\t%lf\n", i, Data_structure.Data_array[i][0], Data_structure.Data_array[i][1]);
	};



	// Parameter file

	infile = fopen("Limit","r");
	fgets(line,sizeof(line),infile);
	i=0;
	while(!feof(infile))
	{
		fgets(line,sizeof(line),infile);
		i++;
	}
	fclose(infile);


	Data_structure.Parameter_no = i;

	infile = fopen("Limit","r");
	fgets(line,sizeof(line),infile);
	i=0;
	while(!feof(infile))
	{	j=0;
		args=strtok(line,"\t");
		while(args !=NULL)
		{
			strcpy(args_1,args);
			for(k=0;k<strlen(args_1);k++)
			{if(args_1[k] == '\n'){args_1[k] = '\0';} }
			if(j==0){Data_structure.Limit_array[i]=atof(args_1);}
			j++;
			args=strtok(NULL,"\t");
		}

		fgets(line,sizeof(line),infile);
		i++;
	}
	fclose(infile);


	for (i = 0; i < Data_structure.Parameter_no ; i++)
	{
		printf ("Limits: %u\t%lf\n", i, Data_structure.Limit_array[i]);
	};


	Data_structure.Iterations = 5000;
	LVM_algorithm(Data_structure_ptr);


	for (i = 0; i < Data_structure.Parameter_no ; i++)
	{
		printf ("Results: %u\t%lf\t%lf\n", i+1, Data_structure.Parameter_array[i][0],Data_structure.Parameter_array[i][1]);
	}getchar();

	for (i = 0; i < Data_structure.Row_no; i++)
	{
		printf ("Fit Data: %u\t%lf\t%lf\t%lf\n", i+1, Data_structure.Result_array[i][0], Data_structure.Result_array[i][1], Data_structure.Result_array[i][2]);
	};



	//Data_structure.Iterations = 1;
	//LVM_algorithm(Data_structure_ptr);

	return 0;


}



